package com.zm.order.tool.server.history;

import com.zm.order.tool.server.model.Refund;
import com.zm.order.tool.server.query.OrderQuery;
import com.zm.order.tool.server.query.RefundQuery;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author penghui
 */
@Repository
public interface HistoryDataRefundDao {


    /**
     * 根据id查询
     *
     * @param refundNo 主键
     * @return
     */
    Refund selectByRefundNo(@Param("refundNo") String refundNo);

    Refund selectById(@Param("id") Long id);

    List<Refund> selectRespId(@Param("list") List<Long> list);


    /**
     * 统计
     *
     * @param query
     * @return
     */
    int count(RefundQuery query);

    /**
     * 查询列表
     *
     * @param query 查询参数
     * @return
     */
    List<Refund> selectList(RefundQuery query);

    /**
     * 查询列表
     *
     * @param query 查询参数
     * @return
     */
    List<Refund> selectListOrder(OrderQuery query);

    List<Long> selectIdList(RefundQuery query);

    /**
     * 查询列表
     *
     * @param query 查询参数
     * @return
     */
    List<Refund> selectListBaseWhere(RefundQuery query);

    List<Refund> selectByIdList(@Param("list") List<Long> idList);

    /**
     * 修改用户id
     *
     * @param id
     * @param userId
     * @return
     */
    int updateUserId(@Param("id") Long id,
                     @Param("userId") Long userId,
                     @Param("sellerId") Long sellerId,
                     @Param("storeId") Long storeId);

    /**
     * 更新退款明细
     *
     * @param refund
     * @return
     */
    int updateRefundDetail(Refund refund);

    /**
     * 查询支提款付金额
     *
     * @param query 查询参数
     * @return
     */
    Integer sumRefundAmount(RefundQuery query);

    /**
     * 更新
     * @param refund
     * @return
     */
    int update(Refund refund);

    int updateBizType(@Param("bizType") Integer bizType, @Param("orderNoList") List<String> orderNoList);

    /**
     * 更新
     * @param refund
     * @return
     */
    int updateDealAt(Refund refund);

    int updateDetailInfo(Refund refund);

    /**
     * 批量更新退款单处理时间
     * @param list
     * @return:
     * @Date: 2021/2/25 10:41 上午
     */
    int batchUpdateDealAt(List<Refund> list);

    /**
     * 批量更新退款单
     * @param list
     * @param bizType
     * @param sellerId
     * @return:
     * @Date: 2021/2/25 10:41 上午
     */
    int updateBatch(@Param("list") List<Refund> list, @Param("bizType") Integer bizType, @Param("sellerId") Long sellerId);


    /**
     * 更新系统来源
     * @param list
     * @return:
     * @Date: 2021/3/5 2:55 下午
     */
    int batchUpdateFromSystem(List<Refund> list);

    /**
     * 更新支付类型
     * @param refund
     * @return
     */
    int updatePayType(Refund refund);

    /**
     *
     * @param list
     * @return
     * Date: 2021/5/24 9:50 上午
     */
    int updateExtraMap(List<Refund> list);

    int delete(@Param("id") Long id, @Param("deleteType") Integer deleteType);

    /**
     * 插入
     *
     * @param record
     * @return
     */
    int insert(Refund record);

    int insertList(List<Refund> list);


    int deleteTemp(@Param("orderNo") String orderNo,
                   @Param("userId") Long userId);

    /**
     * 通过订单号查询退款单
     *
     * @param orderNo
     * @return
     */
    List<Refund> selectByOrderNo(@Param("orderNo") String orderNo);

    int deleteByIdList(@Param("idList") List<Long> idList, @Param("deleteType") Integer deleteType);

    int realDelete(@Param("idList") List<Long> idList);

    int deleteByOrderNos(@Param("orderNoList") List<String> orderNoList);

    /**
     * 插入
     *
     * @param list
     * @return
     */
    void replaceList(@Param("list") List<Refund> list);

}